Index: trunk/NEMO/OPA_SRC/DYN/dynzdf_imp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 503)
@@ -4,4 +4,8 @@
    !! Ocean dynamics:  vertical component(s) of the momentum mixing trend
    !!==============================================================================
+   !! History :      !  90-10  (B. Blanke)  Original code
+   !!                !  97-05  (G. Madec)  vertical component of isopycnal
+   !!           8.5  !  02-08  (G. Madec)  F90: Free form and module
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -11,5 +15,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
    !! * Modules used
@@ -20,5 +24,4 @@
    USE in_out_manager  ! I/O manager
    USE taumod          ! surface ocean stress
-   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -40,5 +43,5 @@
 
 
-   SUBROUTINE dyn_zdf_imp( kt )
+   SUBROUTINE dyn_zdf_imp( kt, p2dt )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dyn_zdf_imp  ***
@@ -58,25 +61,17 @@
       !! ** Action : - Update (ua,va) arrays with the after vertical diffusive
       !!               mixing trend.
-      !!
-      !! History :
-      !!        !  90-10  (B. Blanke)  Original code
-      !!        !  97-05  (G. Madec)  vertical component of isopycnal
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier)  New trends organization
       !!---------------------------------------------------------------------
       !! * Modules used
-      USE oce, ONLY :  zwd   => ta,   &  ! use ta as workspace
-                       zws   => sa       ! use sa as workspace
+      USE oce, ONLY :  zwd   => ta,   &                ! use ta as workspace
+                       zws   => sa                     ! use sa as workspace
 
       !! * Arguments
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+      INTEGER , INTENT( in ) ::   kt                   ! ocean time-step index
+      REAL(wp), INTENT( in ) ::  p2dt                  ! vertical profile of tracer time-step
 
       !! * Local declarations
-      INTEGER ::   ji, jj, jk            ! dummy loop indices
-      REAL(wp) ::   &
-         zrau0r, z2dt,                &  ! temporary scalars
-         z2dtf, zcoef, zzws, zrhs        !    "         "
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         zwi                             ! temporary workspace arrays
+      INTEGER ::   ji, jj, jk                          ! dummy loop indices
+      REAL(wp) ::   zrau0r, z2dtf, zcoef, zzws, zrhs   ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zwi        ! temporary workspace arrays
       !!----------------------------------------------------------------------
 
@@ -90,8 +85,4 @@
       ! --------------------------------
       zrau0r = 1. / rau0      ! inverse of the reference density
-      z2dt   = 2. * rdt       ! Leap-frog environnement
-
-      ! Euler time stepping when starting from rest
-      IF( neuler == 0 .AND. kt == nit000 )   z2dt = rdt
 
       ! 1. Vertical diffusion on u
@@ -104,5 +95,5 @@
          DO jj = 2, jpjm1 
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               zcoef = - z2dt / fse3u(ji,jj,jk)
+               zcoef = - p2dt / fse3u(ji,jj,jk)
                zwi(ji,jj,jk) = zcoef * avmu(ji,jj,jk  ) / fse3uw(ji,jj,jk  )
                zzws          = zcoef * avmu(ji,jj,jk+1) / fse3uw(ji,jj,jk+1)
@@ -150,14 +141,14 @@
 !!! change les resultats (derniers digit, pas significativement + rapide 1* de moins)
 !!!         ua(ji,jj,1) = ub(ji,jj,1)  &
-!!!                      + z2dt * ( ua(ji,jj,1) + taux(ji,jj) / ( fse3u(ji,jj,1)*rau0 ) )
-            z2dtf = z2dt / ( fse3u(ji,jj,1)*rau0 )
+!!!                      + p2dt * ( ua(ji,jj,1) + taux(ji,jj) / ( fse3u(ji,jj,1)*rau0 ) )
+            z2dtf = p2dt / ( fse3u(ji,jj,1)*rau0 )
             ua(ji,jj,1) = ub(ji,jj,1)  &
-                         + z2dt *  ua(ji,jj,1) + z2dtf * taux(ji,jj)
-         END DO
-      END DO
-      DO jk = 2, jpkm1
-         DO jj = 2, jpjm1   
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zrhs = ub(ji,jj,jk) + z2dt * ua(ji,jj,jk)   ! zrhs=right hand side
+                         + p2dt *  ua(ji,jj,1) + z2dtf * taux(ji,jj)
+         END DO
+      END DO
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1   
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zrhs = ub(ji,jj,jk) + p2dt * ua(ji,jj,jk)   ! zrhs=right hand side
                ua(ji,jj,jk) = zrhs - zwi(ji,jj,jk) / zwd(ji,jj,jk-1) * ua(ji,jj,jk-1)
             END DO
@@ -183,5 +174,5 @@
          DO jj = 2, jpjm1   
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               ua(ji,jj,jk) = ( ua(ji,jj,jk) - ub(ji,jj,jk) ) / z2dt
+               ua(ji,jj,jk) = ( ua(ji,jj,jk) - ub(ji,jj,jk) ) / p2dt
             END DO
          END DO
@@ -198,5 +189,5 @@
          DO jj = 2, jpjm1   
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               zcoef = -z2dt / fse3v(ji,jj,jk)
+               zcoef = -p2dt / fse3v(ji,jj,jk)
                zwi(ji,jj,jk) = zcoef * avmv(ji,jj,jk  ) / fse3vw(ji,jj,jk  )
                zzws       = zcoef * avmv(ji,jj,jk+1) / fse3vw(ji,jj,jk+1)
@@ -245,8 +236,8 @@
 !!! change les resultats (derniers digit, pas significativement + rapide 1* de moins)
 !!!         va(ji,jj,1) = vb(ji,jj,1)  &
-!!!                      + z2dt * ( va(ji,jj,1) + tauy(ji,jj) / ( fse3v(ji,jj,1)*rau0 ) )
-            z2dtf = z2dt / ( fse3v(ji,jj,1)*rau0 )
+!!!                      + p2dt * ( va(ji,jj,1) + tauy(ji,jj) / ( fse3v(ji,jj,1)*rau0 ) )
+            z2dtf = p2dt / ( fse3v(ji,jj,1)*rau0 )
             va(ji,jj,1) = vb(ji,jj,1)  &
-                         + z2dt * va(ji,jj,1) + z2dtf * tauy(ji,jj)
+                         + p2dt * va(ji,jj,1) + z2dtf * tauy(ji,jj)
          END DO
       END DO
@@ -254,5 +245,5 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               zrhs = vb(ji,jj,jk) + z2dt * va(ji,jj,jk)   ! zrhs=right hand side
+               zrhs = vb(ji,jj,jk) + p2dt * va(ji,jj,jk)   ! zrhs=right hand side
                va(ji,jj,jk) = zrhs - zwi(ji,jj,jk) / zwd(ji,jj,jk-1) * va(ji,jj,jk-1)
             END DO
@@ -274,31 +265,9 @@
       END DO
 
-! flux de surface doit etre calcule dans trdmod et boootom stress
-! deduit par integration verticale dans trmod pour jpdtdzdf
-!RB      IF( l_trddyn )  THEN 
-!         ! diagnose surface and bottom momentum fluxes
-!         DO jj = 2, jpjm1   
-!            DO ji = fs_2, fs_jpim1   ! vector opt.
-!               ! save the surface forcing momentum fluxes
-!               ztsy(ji,jj) = tauy(ji,jj) / ( fse3v(ji,jj,1)*rau0 )
-!               ztsx(ji,jj) = taux(ji,jj) / ( fse3u(ji,jj,1)*rau0 )
-!               ! save bottom friction momentum fluxes
-!               ikbv   = MIN( mbathy(ji,jj+1), mbathy(ji,jj) )
-!               ikbvm1 = MAX( ikbv-1, 1 )
-!               ztby(ji,jj) = - avmv(ji,jj,ikbv) * va(ji,jj,ikbvm1)   &
-!                  / ( fse3v(ji,jj,ikbvm1)*fse3vw(ji,jj,ikbv) )
-!               ! subtract surface forcing and bottom friction trend from vertical
-!               ! diffusive momentum trend
-!               ztdva(ji,jj,1     ) = ztdva(ji,jj,1     ) - ztsy(ji,jj)
-!               ztdva(ji,jj,ikbvm1) = ztdva(ji,jj,ikbvm1) - ztby(ji,jj)
-!            END DO
-!         END DO
-!      ENDIF
-
       ! Normalization to obtain the general momentum trend va
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1   
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               va(ji,jj,jk) = ( va(ji,jj,jk) - vb(ji,jj,jk) ) / z2dt
+               va(ji,jj,jk) = ( va(ji,jj,jk) - vb(ji,jj,jk) ) / p2dt
             END DO
          END DO
Index: trunk/NEMO/OPA_SRC/DYN/dynzdf_imp_jki.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynzdf_imp_jki.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/DYN/dynzdf_imp_jki.F90	(revision 503)
@@ -4,4 +4,6 @@
    !! Ocean dynamics:  vertical component(s) of the momentum mixing trend
    !!==============================================================================
+   !! History : 8.5  !  02-08  (G. Madec)  auto-tasking option
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -17,5 +19,4 @@
    USE in_out_manager  ! I/O manager
    USE taumod          ! surface ocean stress
-   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -30,9 +31,11 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE dyn_zdf_imp_jki( kt )
+   SUBROUTINE dyn_zdf_imp_jki( kt, p2dt )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE dyn_zdf_imp_jki  ***
@@ -52,24 +55,15 @@
       !! ** Action : - Update (ua,va) arrays with the after vertical diffusive
       !!               mixing trend.
-      !!
-      !! History :
-      !!   8.5  !  02-08  (G. Madec)  auto-tasking option
-      !!   9.0  !  04-08  (C. Talandier)  New trends organization
       !!---------------------------------------------------------------------
-      !! * Modules used     
-      USE oce, ONLY :    ztdua => ta,  & ! use ta as 3D workspace   
-                         ztdva => sa     ! use sa as 3D workspace   
-
       !! * Arguments
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+      INTEGER , INTENT( in ) ::   kt                          ! ocean time-step index
+      REAL(wp), INTENT( in ) ::   p2dt                        ! ocean time-step index
 
       !! * Local declarations
-      INTEGER ::   ji, jj, jk            ! dummy loop indices
-      INTEGER ::   ikst, ikenm2, ikstp1  ! temporary integers
-      REAL(wp) ::  zrau0r, z2dt,       & !temporary scalars
-         &         z2dtf, zcoef, zzws
-      REAL(wp), DIMENSION(jpi,jpk) ::  &
-         zwx, zwy, zwz,                & ! workspace
-         zwd, zws, zwi, zwt
+      INTEGER ::   ji, jj, jk                                 ! dummy loop indices
+      INTEGER ::   ikst, ikenm2, ikstp1                       ! temporary integers
+      REAL(wp) ::  zrau0r, z2dtf, zcoef, zzws                 ! temporary scalars
+      REAL(wp), DIMENSION(jpi,jpk) ::  zwx, zwy, zwz,       & ! workspace
+         &                             zwd, zws, zwi, zwt
       !!----------------------------------------------------------------------
 
@@ -84,8 +78,4 @@
       ! --------------------------------
       zrau0r = 1. / rau0      ! inverse of the reference density
-      z2dt   = 2. * rdt       ! Leap-frog environnement
-
-      ! Euler time stepping when starting from rest
-      IF( neuler == 0 .AND. kt == nit000 )   z2dt = rdt
 
       !                                                ! ===============
@@ -101,10 +91,10 @@
          DO jk = 1, jpkm1
             DO ji = 2, jpim1
-               zcoef = - z2dt / fse3u(ji,jj,jk)
+               zcoef = - p2dt / fse3u(ji,jj,jk)
                zwi(ji,jk) = zcoef * avmu(ji,jj,jk  ) / fse3uw(ji,jj,jk  )
                zzws       = zcoef * avmu(ji,jj,jk+1) / fse3uw(ji,jj,jk+1)
                zws(ji,jk) = zzws * umask(ji,jj,jk+1)
                zwd(ji,jk) = 1. - zwi(ji,jk) - zzws
-               zwy(ji,jk) = ub(ji,jj,jk) + z2dt * ua(ji,jj,jk)
+               zwy(ji,jk) = ub(ji,jj,jk) + p2dt * ua(ji,jj,jk)
             END DO
          END DO
@@ -112,5 +102,5 @@
          ! Surface boudary conditions
          DO ji = 2, jpim1
-            z2dtf = z2dt / ( fse3u(ji,jj,1)*rau0 )
+            z2dtf = p2dt / ( fse3u(ji,jj,1)*rau0 )
             zwi(ji,1) = 0.
             zwd(ji,1) = 1. - zws(ji,1)
@@ -175,5 +165,5 @@
          DO jk = 1, jpkm1
             DO ji = 2, jpim1
-               ua(ji,jj,jk) = ( zwx(ji,jk) - ub(ji,jj,jk) ) / z2dt
+               ua(ji,jj,jk) = ( zwx(ji,jk) - ub(ji,jj,jk) ) / p2dt
             END DO
          END DO
@@ -188,10 +178,10 @@
          DO jk = 1, jpkm1
             DO ji = 2, jpim1
-               zcoef = -z2dt/fse3v(ji,jj,jk)
+               zcoef = -p2dt/fse3v(ji,jj,jk)
                zwi(ji,jk) = zcoef * avmv(ji,jj,jk  ) / fse3vw(ji,jj,jk  )
                zzws       = zcoef * avmv(ji,jj,jk+1) / fse3vw(ji,jj,jk+1)
                zws(ji,jk) =  zzws * vmask(ji,jj,jk+1)
                zwd(ji,jk) = 1. - zwi(ji,jk) - zzws
-               zwy(ji,jk) = vb(ji,jj,jk) + z2dt * va(ji,jj,jk)
+               zwy(ji,jk) = vb(ji,jj,jk) + p2dt * va(ji,jj,jk)
             END DO
          END DO
@@ -199,5 +189,5 @@
          ! Surface boudary conditions
          DO ji = 2, jpim1
-            z2dtf = z2dt / ( fse3v(ji,jj,1)*rau0 )
+            z2dtf = p2dt / ( fse3v(ji,jj,1)*rau0 )
             zwi(ji,1) = 0.e0
             zwd(ji,1) = 1. - zws(ji,1)
@@ -262,5 +252,5 @@
          DO jk = 1, jpkm1
             DO ji = 2, jpim1
-               va(ji,jj,jk) = ( zwx(ji,jk) - vb(ji,jj,jk) ) / z2dt
+               va(ji,jj,jk) = ( zwx(ji,jk) - vb(ji,jj,jk) ) / p2dt
             END DO
          END DO
Index: trunk/NEMO/OPA_SRC/TRA/traadv.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRA/traadv.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRA/traadv.F90	(revision 503)
@@ -4,21 +4,22 @@
    !! Ocean active tracers:  advection trend 
    !!==============================================================================
-   !! History :
-   !!   9.0  !  05-11  (G. Madec)  Original code
+   !! History :  9.0  !  05-11  (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   tra_adv      : compute ocean tracer advection trend
    !!   tra_adv_ctl  : control the different options of advection scheme
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
-   USE traadv_cen2     ! 2nd order centered scheme   (tra_adv_cen2 routine)
-   USE traadv_cen2_jki ! 2nd order centered scheme   (tra_adv_cen2 routine)
-   USE traadv_tvd      ! TVD scheme                (tra_adv_tvd    routine)
-   USE traadv_muscl    ! MUSCL scheme              (tra_adv_muscl  routine)
+   USE traadv_cen2     ! 2nd order centered scheme (tra_adv_cen2   routine)
+   USE traadv_cen2_jki ! 2nd order centered scheme (tra_adv_cen2   routine)
+   USE traadv_tvd      ! TVD    scheme             (tra_adv_tvd    routine)
+   USE traadv_muscl    ! MUSCL  scheme             (tra_adv_muscl  routine)
    USE traadv_muscl2   ! MUSCL2 scheme             (tra_adv_muscl2 routine)
+   USE traadv_ubs      ! UBS    scheme             (tra_adv_ubs    routine)
    USE traadv_eiv      ! eddy induced velocity     (tra_adv_eiv    routine)
-   USE trabbl          ! ???
-   USE ldftra_oce      ! ???
+   USE trabbl          ! tracers: bottom boundary layer
+   USE ldftra_oce      ! lateral diffusion coefficient on tracers
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -27,23 +28,24 @@
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC tra_adv         ! routine called by step module
+   PUBLIC   tra_adv    ! routine called by step module
  
-   !! * Share module variables
-   LOGICAL, PUBLIC ::   &
-      ln_traadv_cen2   = .TRUE.  ,   &  ! 2nd order centered scheme flag
-      ln_traadv_tvd    = .FALSE. ,   &  ! TVD scheme flag
-      ln_traadv_muscl  = .FALSE. ,   &  ! MUSCL scheme flag
-      ln_traadv_muscl2 = .FALSE.        ! MUSCL2 scheme flag
+   !!* Namelist nam_traadv
+   LOGICAL, PUBLIC ::   ln_traadv_cen2   = .TRUE.       ! 2nd order centered scheme flag
+   LOGICAL, PUBLIC ::   ln_traadv_tvd    = .FALSE.      ! TVD scheme flag
+   LOGICAL, PUBLIC ::   ln_traadv_muscl  = .FALSE.      ! MUSCL scheme flag
+   LOGICAL, PUBLIC ::   ln_traadv_muscl2 = .FALSE.      ! MUSCL2 scheme flag
+   LOGICAL, PUBLIC ::   ln_traadv_ubs    = .FALSE.      ! UBS scheme flag
+   NAMELIST/nam_traadv/ ln_traadv_cen2 , ln_traadv_tvd,   &
+      &                 ln_traadv_muscl, ln_traadv_muscl2, ln_traadv_ubs
 
-   !! * Module variables
-   INTEGER ::   &
-      nadv                              ! choice of the type of advection scheme
+   INTEGER ::   nadv   ! choice of the type of advection scheme
 
    !! * Substitutions
-#   include "domzgr_substitute.h90"
-#   include "vectopt_loop_substitute.h90"
+#  include "domzgr_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -56,28 +58,25 @@
       !! ** Purpose :   compute the ocean tracer advection trend.
       !!
+      !! ** Method  : - Update (ua,va) with the advection term following nadv
       !!----------------------------------------------------------------------
 #if ( defined key_trabbl_adv || defined key_traldf_eiv )
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  &  ! temporary arrays
-         &         zun, zvn, zwn
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zun, zvn, zwn   ! effective velocity
 #else
-      USE oce                , zun => un,  &  ! When no advective bbl, zun == un
-         &                     zvn => vn,  &  !      "        "      , zvn == vn
-         &                     zwn => wn      !      "        "      , zwn == wn
+      USE oce, ONLY :                       zun => un       ! the effective velocity is the
+      USE oce, ONLY :                       zvn => vn       ! Eulerian velocity
+      USE oce, ONLY :                       zwn => wn       ! 
 #endif
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step index
+      !!
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!----------------------------------------------------------------------
 
-      IF( kt == nit000 )   CALL tra_adv_ctl                  ! initialisation & control of options
+      IF( kt == nit000 )   CALL tra_adv_ctl          ! initialisation & control of options
 
 #if defined key_trabbl_adv
-      ! Advective bottom boundary layer                      ! add the bbl velocity
-      ! -------------------------------
-      zun(:,:,:) = un(:,:,:) - u_bbl(:,:,:)
+      zun(:,:,:) = un(:,:,:) - u_bbl(:,:,:)          ! add the bbl velocity
       zvn(:,:,:) = vn(:,:,:) - v_bbl(:,:,:)
       zwn(:,:,:) = wn(:,:,:) + w_bbl(:,:,:)
 #endif
-      IF( lk_traldf_eiv ) THEN                               ! add the eiv velocity
+      IF( lk_traldf_eiv ) THEN                       ! commpute and add the eiv velocity
          IF( .NOT. lk_trabbl_adv ) THEN 
             zun(:,:,:) = un(:,:,:)
@@ -85,41 +84,39 @@
             zwn(:,:,:) = wn(:,:,:)
          ENDIF
-         CALL tra_adv_eiv( kt, zun, zvn, zwn )                  ! compute and add the eiv velocity 
+         CALL tra_adv_eiv( kt, zun, zvn, zwn ) 
       ENDIF
 
-      SELECT CASE ( nadv )                       ! compute advection trend and add it to general trend
-      CASE ( -1 )                                       ! esopa: test all possibility with control print
-         CALL tra_adv_cen2    ( kt, zun, zvn, zwn )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_cen2_jki( kt, zun, zvn, zwn )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf1 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_tvd     ( kt, zun, zvn, zwn )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf2 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_muscl   ( kt, zun, zvn, zwn )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf3 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_adv_muscl2  ( kt, zun, zvn, zwn )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf4 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-
-      CASE ( 0 )                                       ! 2nd order centered scheme k-j-i loops
-         CALL tra_adv_cen2    ( kt, zun, zvn, zwn )
-      CASE ( 1 )                                       ! 2nd order centered scheme
-         CALL tra_adv_cen2_jki( kt, zun, zvn, zwn )
-      CASE ( 2 )                                       ! TVD scheme
-         CALL tra_adv_tvd    ( kt, zun, zvn, zwn )
-      CASE ( 3 )                                       ! MUSCL  scheme
-         CALL tra_adv_muscl  ( kt, zun, zvn, zwn )
-      CASE ( 4 )                                       ! MUSCL2 scheme
-         CALL tra_adv_muscl2 ( kt, zun, zvn, zwn )
+      SELECT CASE ( nadv )                           ! compute advection trend and add it to general trend
+      CASE ( 0 )   ;   CALL tra_adv_cen2    ( kt, zun, zvn, zwn )    ! 2nd order centered scheme k-j-i loops
+      CASE ( 1 )   ;   CALL tra_adv_cen2_jki( kt, zun, zvn, zwn )    ! 2nd order centered scheme
+      CASE ( 2 )   ;   CALL tra_adv_tvd     ( kt, zun, zvn, zwn )    ! TVD    scheme
+      CASE ( 3 )   ;   CALL tra_adv_muscl   ( kt, zun, zvn, zwn )    ! MUSCL  scheme
+      CASE ( 4 )   ;   CALL tra_adv_muscl2  ( kt, zun, zvn, zwn )    ! MUSCL2 scheme
+      CASE ( 5 )   ;   CALL tra_adv_ubs     ( kt, zun, zvn, zwn )    ! UBS    scheme
+      !
+      CASE (-1 )                                                     ! esopa: test all possibility with control print
+         ;             CALL tra_adv_cen2    ( kt, zun, zvn, zwn )
+         ;             CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
+            &                        tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         ;             CALL tra_adv_cen2_jki( kt, zun, zvn, zwn )
+         ;             CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf1 - Ta: ', mask1=tmask,               &
+            &                        tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         ;             CALL tra_adv_tvd     ( kt, zun, zvn, zwn )
+         ;             CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf2 - Ta: ', mask1=tmask,               &
+            &                        tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         ;             CALL tra_adv_muscl   ( kt, zun, zvn, zwn )
+         ;             CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf3 - Ta: ', mask1=tmask,               &
+            &                        tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         ;             CALL tra_adv_muscl2  ( kt, zun, zvn, zwn )
+         ;             CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf4 - Ta: ', mask1=tmask,               &
+            &                        tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+         ;             CALL tra_adv_ubs     ( kt, zun, zvn, zwn )
+         ;             CALL prt_ctl( tab3d_1=ta, clinfo1=' adv5 - Ta: ', mask1=tmask,               &
+            &                        tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       END SELECT
-
-      !                                                ! print mean trends (used for debugging)
-!      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' adv  - Ta: ', mask1=tmask,               &
-!         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-
+      !                                              ! print mean trends (used for debugging)
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' adv  - Ta: ', mask1=tmask,               &
+         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      !
    END SUBROUTINE tra_adv
 
@@ -129,63 +126,60 @@
       !!                  ***  ROUTINE tra_adv_ctl  ***
       !!                
-      !! ** Purpose :   Control the consistency between cpp options for 
-      !!      tracer advection schemes
-      !!
+      !! ** Purpose :   Control the consistency between namelist options for 
+      !!              tracer advection schemes and set nadv
       !!----------------------------------------------------------------------
       INTEGER ::   ioptio
-      NAMELIST/nam_traadv/ ln_traadv_cen2 , ln_traadv_tvd,   &
-         &                 ln_traadv_muscl, ln_traadv_muscl2
       !!----------------------------------------------------------------------
 
-      ! Read Namelist nam_traadv : tracer advection scheme
-      ! -------------------------
-      REWIND ( numnam )
+      REWIND ( numnam )               ! Read Namelist nam_traadv : tracer advection scheme
       READ   ( numnam, nam_traadv )
 
-      ! Parameter control and print
-      ! ---------------------------
-      ! Control print
-      IF(lwp) THEN
+      IF(lwp) THEN                    ! Namelist print
          WRITE(numout,*)
          WRITE(numout,*) 'tra_adv_ctl : choice/control of the tracer advection scheme'
          WRITE(numout,*) '~~~~~~~~~~~'
-         WRITE(numout,*) '          Namelist nam_tra_adv : chose a advection scheme for tracers'
-         WRITE(numout,*)
-         WRITE(numout,*) '             2nd order advection scheme     ln_traadv_cen2   = ', ln_traadv_cen2
-         WRITE(numout,*) '             TVD advection scheme           ln_traadv_tvd    = ', ln_traadv_tvd
-         WRITE(numout,*) '             MUSCL  advection scheme        ln_traadv_muscl  = ', ln_traadv_muscl
-         WRITE(numout,*) '             MUSCL2 advection scheme        ln_traadv_muscl2 = ', ln_traadv_muscl2
+         WRITE(numout,*) '       Namelist nam_traadv : chose a advection scheme for tracers'
+         WRITE(numout,*) '          2nd order advection scheme     ln_traadv_cen2   = ', ln_traadv_cen2
+         WRITE(numout,*) '          TVD advection scheme           ln_traadv_tvd    = ', ln_traadv_tvd
+         WRITE(numout,*) '          MUSCL  advection scheme        ln_traadv_muscl  = ', ln_traadv_muscl
+         WRITE(numout,*) '          MUSCL2 advection scheme        ln_traadv_muscl2 = ', ln_traadv_muscl2
+         WRITE(numout,*) '          UBS    advection scheme        ln_traadv_ubs    = ', ln_traadv_ubs
       ENDIF
 
-      ! Control of Advection scheme options
-      ! -----------------------------------
-      ioptio = 0
+      ioptio = 0                      ! Parameter control
       IF( ln_traadv_cen2   )   ioptio = ioptio + 1
       IF( ln_traadv_tvd    )   ioptio = ioptio + 1
       IF( ln_traadv_muscl  )   ioptio = ioptio + 1
       IF( ln_traadv_muscl2 )   ioptio = ioptio + 1
+      IF( ln_traadv_ubs    )   ioptio = ioptio + 1
+      IF( lk_esopa         )   ioptio =          1
 
-      IF( .NOT.lk_esopa .AND. ( ioptio > 1 .OR. ioptio == 0 ) ) &
-           &   CALL ctl_stop( ' Choose ONE advection scheme in namelist nam_traadv' )
+      IF( ioptio /= 1 )   CALL ctl_stop( 'Choose ONE advection scheme in namelist nam_traadv' )
 
-      IF( n_cla == 1 .AND. .NOT. ln_traadv_cen2 ) &
-           &   CALL ctl_stop( '     cross-land advection only with 2nd order advection scheme' )
+      IF( n_cla == 1 .AND. .NOT. ln_traadv_cen2 )   &
+         &                CALL ctl_stop( 'cross-land advection only with 2nd order advection scheme' )
 
-      ! Set nadv
-      ! --------
-      IF( ln_traadv_cen2   )   nadv = 0
+      !                              ! Set nadv
+      IF( ln_traadv_cen2   )   nadv =  0
 #if defined key_mpp_omp
-      IF( ln_traadv_cen2   )   nadv = 1
+      IF( ln_traadv_cen2   )   nadv =  1
 #endif
-      IF( ln_traadv_tvd    )   nadv = 2
-      IF( ln_traadv_muscl  )   nadv = 3
-      IF( ln_traadv_muscl2 )   nadv = 4
+      IF( ln_traadv_tvd    )   nadv =  2
+      IF( ln_traadv_muscl  )   nadv =  3
+      IF( ln_traadv_muscl2 )   nadv =  4
+      IF( ln_traadv_ubs    )   nadv =  5
+      IF( lk_esopa         )   nadv = -1
 
-      IF( lk_esopa ) THEN
-         IF(lwp) WRITE(numout,*) '          esopa control: use all lateral physics options'
-         nadv = -1
+      IF(lwp) THEN                   ! Print the choice
+         WRITE(numout,*)
+         IF( nadv ==  0 )   WRITE(numout,*) '         2nd order scheme is used'
+         IF( nadv ==  1 )   WRITE(numout,*) '         2nd order scheme is usedi, k-j-i case'
+         IF( nadv ==  2 )   WRITE(numout,*) '         TVD       scheme is used'
+         IF( nadv ==  3 )   WRITE(numout,*) '         MUSCL     scheme is used'
+         IF( nadv ==  4 )   WRITE(numout,*) '         MUSCL2    scheme is used'
+         IF( nadv ==  5 )   WRITE(numout,*) '         UBS       scheme is used'
+         IF( nadv == -1 )   WRITE(numout,*) '         esopa test: use all advection scheme'
       ENDIF
-      IF(lwp) WRITE(numout,*) '             choice of tra_adv_...                nadv   = ', nadv
-
+      !
    END SUBROUTINE tra_adv_ctl
 
